/*
 * Copyright 2009 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.cementframework.querybyproxy.hql.impl.compiler.alias;

/**
 * The immutable resolved entity-proxy jpql alias.
 *
 * @author allenparslow
 */
public class IdentifactionVariableImpl implements IdentifactionVariable {
    private final String name;
    private final String path;
    private final Object target;

    /**
     * Create a new <code>QueryAliasImpl</code> instance.
     *
     * @param name the alias's identifier for the entity-proxy.
     * @param path the path stem for the entity-proxy.
     * @param target the target proxy for the alias.
     */
    public IdentifactionVariableImpl(String name, String path, Object target) {
        this.name = name;
        this.path = path;
        this.target = target;
    }

    /**
     * {@inheritDoc}
     */
    public String getPath() {
        return path;
    }

    /**
     * {@inheritDoc}
     */
    public Object getTargetProxy() {
        return target;
    }

    /**
     * {@inheritDoc}
     */
    public String getName() {
        return name;
    }

    @Override
    public String toString() {
        return name;
    }
}
