/*
 * Copyright 2009 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.cementframework.querybyproxy.hql.jpa.impl;

import java.util.List;

import org.cementframework.querybyproxy.hql.jpa.api.JpaProxyQuery;
import org.cementframework.querybyproxy.shared.api.DynamicQuery;

/**
 * A non-typed qbp (query-by-proxy) query.
 *
 * @author allenparslow
 */
public class JpaDynamicQueryImpl extends JpaAbstractQuery<Object> implements DynamicQuery {

    /**
     * Create a new <code>DynamicMultiQueryImpl</code> instance.
     * @param query the target proxy-query.
     */
    @SuppressWarnings("unchecked")
    public JpaDynamicQueryImpl(JpaProxyQuery query) {
        super(query);
    }

    /**
     * {@inheritDoc}
     */
    public Object[] findSingle() {
        return (Object[]) build().getSingleResult();
    }

    /**
     * {@inheritDoc}
     */
    @SuppressWarnings("unchecked")
    public List<Object[]> find() {

        List<Object[]> results = (List<Object[]>) build().getResultList();

        return results;
    }

//    /**
//     * {@inheritDoc}
//     */
//    public DynamicQuery limit(int maxResult) {
//        getJavaxQuery().setMaxResults(maxResult);
//        return this;
//    }
//
//    /**
//     * {@inheritDoc}
//     */
//    public DynamicQuery page(int startPosition) {
//        getJavaxQuery().setFirstResult(startPosition);
//        return this;
//    }
}
